Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/generic/src/proc/thread.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -76,5 +76,5 @@
 
 /** Thread states */
-char *thread_states[] = {
+const char *thread_states[] = {
 	"Invalid",
 	"Running",
@@ -288,5 +288,5 @@
  */
 thread_t *thread_create(void (* func)(void *), void *arg, task_t *task,
-    int flags, char *name, bool uncounted)
+    int flags, const char *name, bool uncounted)
 {
 	thread_t *t;
Index: kernel/generic/src/synch/spinlock.c
===================================================================
--- kernel/generic/src/synch/spinlock.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/generic/src/synch/spinlock.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -52,5 +52,5 @@
  *
  */
-void spinlock_initialize(spinlock_t *lock, char *name)
+void spinlock_initialize(spinlock_t *lock, const char *name)
 {
 	atomic_set(&lock->val, 0);
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -225,5 +225,5 @@
 		int i;
 		unative_t val = 0;
-		char *vtype = NULL;
+		const char *vtype = NULL;
 		
 		
Index: kernel/test/atomic/atomic1.c
===================================================================
--- kernel/test/atomic/atomic1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/atomic/atomic1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -32,5 +32,5 @@
 #include <debug.h>
 
-char *test_atomic1(void)
+const char *test_atomic1(void)
 {
 	atomic_t a;
Index: kernel/test/avltree/avltree1.c
===================================================================
--- kernel/test/avltree/avltree1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/avltree/avltree1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -265,5 +265,5 @@
 }
 
-char *test_avltree1(void)
+const char *test_avltree1(void)
 {
 	alloc_avltree_node_prepare();
Index: kernel/test/btree/btree1.c
===================================================================
--- kernel/test/btree/btree1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/btree/btree1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -34,5 +34,5 @@
 static void *data = (void *) 0xdeadbeef;
 
-char *test_btree1(void)
+const char *test_btree1(void)
 {
 	btree_t t;
Index: kernel/test/debug/mips1.c
===================================================================
--- kernel/test/debug/mips1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/debug/mips1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -37,5 +37,5 @@
 #include <arch.h>
 
-char *test_mips1(void)
+const char *test_mips1(void)
 {
 	TPRINTF("If kconsole is compiled in, you should enter debug mode now.\n");
Index: kernel/test/debug/mips1_skip.c
===================================================================
--- kernel/test/debug/mips1_skip.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/debug/mips1_skip.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-char *test_mips1(void)
+const char *test_mips1(void)
 {
 	return NULL;
Index: kernel/test/fault/fault1.c
===================================================================
--- kernel/test/fault/fault1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fault/fault1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -37,5 +37,5 @@
 #include <arch.h>
 
-char *test_fault1(void)
+const char *test_fault1(void)
 {
 	((int *)(0))[1] = 0;
Index: kernel/test/fpu/fpu1_ia64.c
===================================================================
--- kernel/test/fpu/fpu1_ia64.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/fpu1_ia64.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -126,5 +126,5 @@
 }
 
-char *test_fpu1(void)
+const char *test_fpu1(void)
 {
 	unsigned int i;
Index: kernel/test/fpu/fpu1_skip.c
===================================================================
--- kernel/test/fpu/fpu1_skip.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/fpu1_skip.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-char *test_fpu1(void)
+const char *test_fpu1(void)
 {
 	return NULL;
Index: kernel/test/fpu/fpu1_x86.c
===================================================================
--- kernel/test/fpu/fpu1_x86.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/fpu1_x86.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -123,5 +123,5 @@
 }
 
-char *test_fpu1(void)
+const char *test_fpu1(void)
 {
 	unsigned int i;
Index: kernel/test/fpu/mips2.c
===================================================================
--- kernel/test/fpu/mips2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/mips2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -109,5 +109,5 @@
 
 
-char *test_mips2(void)
+const char *test_mips2(void)
 {
 	unsigned int i;
Index: kernel/test/fpu/mips2_skip.c
===================================================================
--- kernel/test/fpu/mips2_skip.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/mips2_skip.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-char *test_mips2(void)
+const char *test_mips2(void)
 {
 	return NULL;
Index: kernel/test/fpu/sse1.c
===================================================================
--- kernel/test/fpu/sse1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/sse1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -107,5 +107,5 @@
 }
 
-char *test_sse1(void)
+const char *test_sse1(void)
 {
 	unsigned int i;
Index: kernel/test/fpu/sse1_skip.c
===================================================================
--- kernel/test/fpu/sse1_skip.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/fpu/sse1_skip.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-char *test_sse1(void)
+const char *test_sse1(void)
 {
 	return NULL;
Index: kernel/test/mm/falloc1.c
===================================================================
--- kernel/test/mm/falloc1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/falloc1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -41,5 +41,5 @@
 #define TEST_RUNS   2
 
-char *test_falloc1(void) {
+const char *test_falloc1(void) {
 	uintptr_t *frames
 	    = (uintptr_t *) malloc(MAX_FRAMES * sizeof(uintptr_t), 0);
Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/falloc2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -104,5 +104,5 @@
 }
 
-char *test_falloc2(void)
+const char *test_falloc2(void)
 {
 	unsigned int i;
Index: kernel/test/mm/mapping1.c
===================================================================
--- kernel/test/mm/mapping1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/mapping1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -42,5 +42,5 @@
 #define VALUE1  0x89abcdef
 
-char *test_mapping1(void)
+const char *test_mapping1(void)
 {
 	uintptr_t frame0, frame1;
Index: kernel/test/mm/purge1.c
===================================================================
--- kernel/test/mm/purge1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/purge1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -40,5 +40,5 @@
 extern void tlb_invalidate_pages(asid_t asid, uintptr_t va, size_t cnt);
 
-char *test_purge1(void)
+const char *test_purge1(void)
 {
 	tlb_entry_t entryi;
Index: kernel/test/mm/purge1_skip.c
===================================================================
--- kernel/test/mm/purge1_skip.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/purge1_skip.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-char *test_purge1(void)
+const char *test_purge1(void)
 {
 	return NULL;
Index: kernel/test/mm/slab1.c
===================================================================
--- kernel/test/mm/slab1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/slab1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -170,5 +170,5 @@
 }
 
-char *test_slab1(void)
+const char *test_slab1(void)
 {
 	testsimple();
Index: kernel/test/mm/slab2.c
===================================================================
--- kernel/test/mm/slab2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/mm/slab2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -226,5 +226,5 @@
 }
 
-char *test_slab2(void)
+const char *test_slab2(void)
 {
 	TPRINTF("Running reclaim single-thread test .. pass 1\n");
Index: kernel/test/print/print1.c
===================================================================
--- kernel/test/print/print1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/print/print1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -30,5 +30,5 @@
 #include <test.h>
 
-char *test_print1(void)
+const char *test_print1(void)
 {
 	TPRINTF("Testing printf(\"%%*.*s\", 5, 3, \"text\"):\n");
Index: kernel/test/print/print2.c
===================================================================
--- kernel/test/print/print2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/print/print2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -30,5 +30,5 @@
 #include <test.h>
 
-char *test_print2(void)
+const char *test_print2(void)
 {
 	TPRINTF("Testing printf(\"%%c %%3.2c %%-3.2c %%2.3c %%-2.3c\", 'a', 'b', 'c', 'd', 'e'):\n");
Index: kernel/test/print/print3.c
===================================================================
--- kernel/test/print/print3.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/print/print3.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -33,5 +33,5 @@
 #define BUFFER_SIZE  32
 
-char *test_print3(void)
+const char *test_print3(void)
 {
 	char buffer[BUFFER_SIZE];
Index: kernel/test/print/print4.c
===================================================================
--- kernel/test/print/print4.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/print/print4.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -30,5 +30,5 @@
 #include <test.h>
 
-char *test_print4(void)
+const char *test_print4(void)
 {
 	TPRINTF("ASCII printable characters (32 - 127) using printf(\"%%c\") and printf(\"%%lc\"):\n");
Index: kernel/test/synch/rwlock1.c
===================================================================
--- kernel/test/synch/rwlock1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/rwlock1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -41,5 +41,5 @@
 static rwlock_t rwlock;
 
-char *test_rwlock1(void)
+const char *test_rwlock1(void)
 {
 	rwlock_initialize(&rwlock);
Index: kernel/test/synch/rwlock2.c
===================================================================
--- kernel/test/synch/rwlock2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/rwlock2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -53,5 +53,5 @@
 }
 
-char *test_rwlock2(void)
+const char *test_rwlock2(void)
 {
 	thread_t *thrd;
Index: kernel/test/synch/rwlock3.c
===================================================================
--- kernel/test/synch/rwlock3.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/rwlock3.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -60,5 +60,5 @@
 }
 
-char *test_rwlock3(void)
+const char *test_rwlock3(void)
 {
 	int i;
Index: kernel/test/synch/rwlock4.c
===================================================================
--- kernel/test/synch/rwlock4.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/rwlock4.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -132,5 +132,5 @@
 }
 
-char *test_rwlock4(void)
+const char *test_rwlock4(void)
 {
 	context_t ctx;
Index: kernel/test/synch/rwlock5.c
===================================================================
--- kernel/test/synch/rwlock5.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/rwlock5.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -67,5 +67,5 @@
 }
 
-char *test_rwlock5(void)
+const char *test_rwlock5(void)
 {
 	int i, j, k;
Index: kernel/test/synch/semaphore1.c
===================================================================
--- kernel/test/synch/semaphore1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/semaphore1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -70,5 +70,5 @@
 }
 
-char *test_semaphore1(void)
+const char *test_semaphore1(void)
 {
 	int i, j, k;
Index: kernel/test/synch/semaphore2.c
===================================================================
--- kernel/test/synch/semaphore2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/synch/semaphore2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -82,5 +82,5 @@
 }
 
-char *test_semaphore2(void)
+const char *test_semaphore2(void)
 {
 	uint32_t i, k;
Index: kernel/test/sysinfo/sysinfo1.c
===================================================================
--- kernel/test/sysinfo/sysinfo1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/sysinfo/sysinfo1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -33,5 +33,5 @@
 #include <sysinfo/sysinfo.h>
 
-char *test_sysinfo1(void)
+const char *test_sysinfo1(void)
 {
 	if (!test_quiet)
Index: kernel/test/test.h
===================================================================
--- kernel/test/test.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/test.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -48,40 +48,40 @@
 	}
 
-typedef char *(*test_entry_t)(void);
+typedef const char *(*test_entry_t)(void);
 
 typedef struct {
-	char *name;
-	char *desc;
+	const char *name;
+	const char *desc;
 	test_entry_t entry;
 	bool safe;
 } test_t;
 
-extern char *test_atomic1(void);
-extern char *test_avltree1(void);
-extern char *test_btree1(void);
-extern char *test_mips1(void);
-extern char *test_fault1(void);
-extern char *test_fpu1(void);
-extern char *test_sse1(void);
-extern char *test_mips2(void);
-extern char *test_falloc1(void);
-extern char *test_falloc2(void);
-extern char *test_mapping1(void);
-extern char *test_purge1(void);
-extern char *test_slab1(void);
-extern char *test_slab2(void);
-extern char *test_rwlock1(void);
-extern char *test_rwlock2(void);
-extern char *test_rwlock3(void);
-extern char *test_rwlock4(void);
-extern char *test_rwlock5(void);
-extern char *test_semaphore1(void);
-extern char *test_semaphore2(void);
-extern char *test_print1(void);
-extern char *test_print2(void);
-extern char *test_print3(void);
-extern char *test_print4(void);
-extern char *test_thread1(void);
-extern char *test_sysinfo1(void);
+extern const char *test_atomic1(void);
+extern const char *test_avltree1(void);
+extern const char *test_btree1(void);
+extern const char *test_mips1(void);
+extern const char *test_fault1(void);
+extern const char *test_fpu1(void);
+extern const char *test_sse1(void);
+extern const char *test_mips2(void);
+extern const char *test_falloc1(void);
+extern const char *test_falloc2(void);
+extern const char *test_mapping1(void);
+extern const char *test_purge1(void);
+extern const char *test_slab1(void);
+extern const char *test_slab2(void);
+extern const char *test_rwlock1(void);
+extern const char *test_rwlock2(void);
+extern const char *test_rwlock3(void);
+extern const char *test_rwlock4(void);
+extern const char *test_rwlock5(void);
+extern const char *test_semaphore1(void);
+extern const char *test_semaphore2(void);
+extern const char *test_print1(void);
+extern const char *test_print2(void);
+extern const char *test_print3(void);
+extern const char *test_print4(void);
+extern const char *test_thread1(void);
+extern const char *test_sysinfo1(void);
 
 extern test_t tests[];
Index: kernel/test/thread/thread1.c
===================================================================
--- kernel/test/thread/thread1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ kernel/test/thread/thread1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -53,5 +53,5 @@
 }
 
-char *test_thread1(void)
+const char *test_thread1(void)
 {
 	unsigned int i;
Index: uspace/app/bdsh/cmds/builtins/cd/cd.c
===================================================================
--- uspace/app/bdsh/cmds/builtins/cd/cd.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/builtins/cd/cd.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -41,5 +41,5 @@
 #include "cd.h"
 
-static char * cmdname = "cd";
+static const char *cmdname = "cd";
 
 void help_cmd_cd(unsigned int level)
Index: uspace/app/bdsh/cmds/cmds.h
===================================================================
--- uspace/app/bdsh/cmds/cmds.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/cmds.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -33,6 +33,6 @@
 /* Module structure */
 typedef struct {
-	char *name;         /* Name of the command */
-	char *desc;         /* Description of the command */
+	const char *name;   /* Name of the command */
+	const char *desc;   /* Description of the command */
 	mod_entry_t entry;  /* Command (exec) entry function */
 	mod_help_t help;    /* Command (help) entry function */
@@ -41,6 +41,6 @@
 /* Builtin structure, same as modules except different types of entry points */
 typedef struct {
-	char *name;
-	char *desc;
+	const char *name;
+	const char *desc;
 	builtin_entry_t entry;
 	builtin_help_t help;
@@ -57,5 +57,5 @@
 extern int is_module(const char *);
 extern int is_module_alias(const char *);
-extern char * alias_for_module(const char *);
+extern char *alias_for_module(const char *);
 extern int help_module(int, unsigned int);
 extern int run_module(int, char *[]);
@@ -65,5 +65,5 @@
 extern int is_builtin(const char *);
 extern int is_builtin_alias(const char *);
-extern char * alias_for_builtin(const char *);
+extern char *alias_for_builtin(const char *);
 extern int help_builtin(int, unsigned int);
 extern int run_builtin(int, char *[], cliuser_t *);
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -43,9 +43,9 @@
 #include "cmds.h"
 
-static char *cmdname = "cat";
+static const char *cmdname = "cat";
 #define CAT_VERSION "0.0.1"
 #define CAT_DEFAULT_BUFLEN 1024
 
-static char *cat_oops = "That option is not yet supported\n";
+static const char *cat_oops = "That option is not yet supported\n";
 
 static struct option const long_options[] = {
Index: uspace/app/bdsh/cmds/modules/help/help.c
===================================================================
--- uspace/app/bdsh/cmds/modules/help/help.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/help/help.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -42,5 +42,5 @@
 #include "util.h"
 
-static char *cmdname = "help";
+static const char *cmdname = "help";
 extern const char *progname;
 
Index: uspace/app/bdsh/cmds/modules/kcon/kcon.c
===================================================================
--- uspace/app/bdsh/cmds/modules/kcon/kcon.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/kcon/kcon.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -40,5 +40,5 @@
 #include "cmds.h"
 
-static char *cmdname = "kcon";
+static const char *cmdname = "kcon";
 
 /* Dispays help for kcon in various levels */
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -49,5 +49,5 @@
 #include "cmds.h"
 
-static char *cmdname = "ls";
+static const char *cmdname = "ls";
 
 static void ls_scan_dir(const char *d, DIR *dirp)
Index: uspace/app/bdsh/cmds/modules/mkdir/mkdir.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkdir/mkdir.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/mkdir/mkdir.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -49,5 +49,5 @@
 #define MKDIR_VERSION "0.0.1"
 
-static char *cmdname = "mkdir";
+static const char *cmdname = "mkdir";
 
 static struct option const long_options[] = {
Index: uspace/app/bdsh/cmds/modules/mkfile/mkfile.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -51,5 +51,5 @@
 #define BUFFER_SIZE 16384
 
-static char *cmdname = "mkfile";
+static const char *cmdname = "mkfile";
 
 static struct option const long_options[] = {
Index: uspace/app/bdsh/cmds/modules/module_aliases.h
===================================================================
--- uspace/app/bdsh/cmds/modules/module_aliases.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/module_aliases.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -12,5 +12,5 @@
  * the entry point being reached. */
 
-char *mod_aliases[] = {
+const char *mod_aliases[] = {
 	"ren", "mv",
 	"umount", "unmount",
Index: uspace/app/bdsh/cmds/modules/mount/mount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mount/mount.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/mount/mount.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -58,5 +58,5 @@
 {
 	unsigned int argc;
-	char *mopts = "";
+	const char *mopts = "";
 	int rc;
 
Index: uspace/app/bdsh/cmds/modules/pwd/pwd.c
===================================================================
--- uspace/app/bdsh/cmds/modules/pwd/pwd.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/pwd/pwd.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -39,5 +39,5 @@
 #include "pwd.h"
 
-static char * cmdname = "pwd";
+static const char *cmdname = "pwd";
 
 void help_cmd_pwd(unsigned int level)
Index: uspace/app/bdsh/cmds/modules/rm/rm.c
===================================================================
--- uspace/app/bdsh/cmds/modules/rm/rm.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/rm/rm.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -45,5 +45,5 @@
 #include "cmds.h"
 
-static char *cmdname = "rm";
+static const char *cmdname = "rm";
 #define RM_VERSION "0.0.1"
 
Index: uspace/app/bdsh/cmds/modules/sleep/sleep.c
===================================================================
--- uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/sleep/sleep.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -38,5 +38,5 @@
 #include "cmds.h"
 
-static char *cmdname = "sleep";
+static const char *cmdname = "sleep";
 
 /* Dispays help for sleep in various levels */
Index: uspace/app/bdsh/cmds/modules/touch/touch.c
===================================================================
--- uspace/app/bdsh/cmds/modules/touch/touch.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/cmds/modules/touch/touch.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -47,5 +47,5 @@
 #include "cmds.h"
 
-static char *cmdname = "touch";
+static const char *cmdname = "touch";
 
 /* Dispays help for touch in various levels */
Index: uspace/app/bdsh/errors.c
===================================================================
--- uspace/app/bdsh/errors.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/errors.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -47,5 +47,5 @@
 /* Look up errno in cl_errors and return the corresponding string.
  * Return NULL if not found */
-static char *err2str(int err)
+static const char *err2str(int err)
 {
 
Index: uspace/app/bdsh/errstr.h
===================================================================
--- uspace/app/bdsh/errstr.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/errstr.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -4,5 +4,5 @@
 /* Simple array to translate error codes to meaningful strings */
 
-static char *cl_errors[] = {
+static const char *cl_errors[] = {
 	"Success",
 	"Failure",
@@ -18,5 +18,5 @@
 };
 
-static char *err2str(int);
+static const char *err2str(int);
 
 #endif
Index: uspace/app/bdsh/exec.c
===================================================================
--- uspace/app/bdsh/exec.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/exec.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -120,5 +120,5 @@
 	free(found);
 
-	tid = task_spawn((const char *)tmp, argv);
+	tid = task_spawn(tmp, (const char **) argv);
 	free(tmp);
 
Index: uspace/app/bdsh/scli.h
===================================================================
--- uspace/app/bdsh/scli.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/bdsh/scli.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -6,5 +6,5 @@
 
 typedef struct {
-	char *name;
+	const char *name;
 	char *line;
 	char *cwd;
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/edit/edit.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -475,8 +475,7 @@
 static void file_save_as(void)
 {
-	char *old_fname, *fname;
-	int rc;
-
-	old_fname = (doc.file_name != NULL) ? doc.file_name : "";
+	const char *old_fname = (doc.file_name != NULL) ? doc.file_name : "";
+	char *fname;
+	
 	fname = filename_prompt("Save As", old_fname);
 	if (fname == NULL) {
@@ -485,5 +484,5 @@
 	}
 
-	rc = file_save(fname);
+	int rc = file_save(fname);
 	if (rc != EOK)
 		return;
@@ -819,15 +818,13 @@
 	spt_t caret_pt;
 	coord_t coord;
-	char *fname;
-	int n;
 
 	tag_get_pt(&pane.caret_pos, &caret_pt);
 	spt_get_coord(&caret_pt, &coord);
 
-	fname = (doc.file_name != NULL) ? doc.file_name : "<unnamed>";
+	const char *fname = (doc.file_name != NULL) ? doc.file_name : "<unnamed>";
 
 	console_goto(con, 0, scr_rows - 1);
 	console_set_color(con, COLOR_WHITE, COLOR_BLACK, 0);
-	n = printf(" %d, %d: File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
+	int n = printf(" %d, %d: File '%s'. Ctrl-Q Quit  Ctrl-S Save  "
 	    "Ctrl-E Save As", coord.row, coord.column, fname);
 	printf("%*s", scr_columns - 1 - n, "");
Index: uspace/app/getterm/getterm.c
===================================================================
--- uspace/app/getterm/getterm.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/getterm/getterm.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -69,7 +69,7 @@
 }
 
-static task_id_t spawn(char *fname)
+static task_id_t spawn(const char *fname)
 {
-	char *args[2];
+	const char *args[2];
 	
 	args[0] = fname;
Index: uspace/app/getterm/version.c
===================================================================
--- uspace/app/getterm/version.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/getterm/version.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -40,18 +40,18 @@
 #include "version.h"
 
-static char *release = STRING(RELEASE);
-static char *name = STRING(NAME);
-static char *arch = STRING(UARCH);
+static const char *release = STRING(RELEASE);
+static const char *name = STRING(NAME);
+static const char *arch = STRING(UARCH);
 
 #ifdef REVISION
-	static char *revision = ", revision " STRING(REVISION);
+	static const char *revision = ", revision " STRING(REVISION);
 #else
-	static char *revision = "";
+	static const char *revision = "";
 #endif
 
 #ifdef TIMESTAMP
-	static char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
+	static const char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
 #else
-	static char *timestamp = "";
+	static const char *timestamp = "";
 #endif
 
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/init/init.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -62,5 +62,5 @@
 static bool mount_root(const char *fstype)
 {
-	char *opts = "";
+	const char *opts = "";
 	const char *root_dev = "bd/initrd";
 	
@@ -117,7 +117,7 @@
 }
 
-static void spawn(char *fname)
-{
-	char *argv[2];
+static void spawn(const char *fname)
+{
+	const char *argv[2];
 	struct stat s;
 	
@@ -134,7 +134,7 @@
 }
 
-static void srv_start(char *fname)
-{
-	char *argv[2];
+static void srv_start(const char *fname)
+{
+	const char *argv[2];
 	task_id_t id;
 	task_exit_t texit;
@@ -168,7 +168,7 @@
 }
 
-static void console(char *dev)
-{
-	char *argv[3];
+static void console(const char *dev)
+{
+	const char *argv[3];
 	char hid_in[DEVMAP_NAME_MAXLEN];
 	int rc;
@@ -193,7 +193,7 @@
 }
 
-static void getterm(char *dev, char *app)
-{
-	char *argv[4];
+static void getterm(const char *dev, const char *app)
+{
+	const char *argv[4];
 	char term[DEVMAP_NAME_MAXLEN];
 	int rc;
Index: uspace/app/redir/redir.c
===================================================================
--- uspace/app/redir/redir.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/redir/redir.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -72,5 +72,5 @@
 static task_id_t spawn(int argc, char *argv[])
 {
-	char **args = (char **) calloc(argc + 1, sizeof(char *));
+	const char **args = (const char **) calloc(argc + 1, sizeof(char *));
 	if (!args) {
 		printf("No memory available\n");
Index: uspace/app/tester/console/console1.c
===================================================================
--- uspace/app/tester/console/console1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/console/console1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -36,5 +36,5 @@
 #include "../tester.h"
 
-const char *color_name[] = {
+static const char *color_name[] = {
 	[COLOR_BLACK] = "black",
 	[COLOR_BLUE] = "blue",
@@ -47,5 +47,5 @@
 };
 
-char *test_console1(void)
+const char *test_console1(void)
 {
 	if (!test_quiet) {
Index: uspace/app/tester/fault/fault1.c
===================================================================
--- uspace/app/tester/fault/fault1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/fault/fault1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -30,5 +30,5 @@
 #include "../tester.h"
 
-char *test_fault1(void)
+const char *test_fault1(void)
 {
 	((int *)(0))[1] = 0;
